<?php 
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('max_execution_time', '0'); //300 seconds = 5 minutes
error_reporting(E_ALL);
ini_set('memory_limit', '-1');
ini_set('error_log', 'logfile.log');
?>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List of organization</title>

    <style>
        body {
            font-family: Neue Plak,-apple-system,BlinkMacSystemFont,Roboto,Helvetica Neue,Helvetica,Tahoma,Arial,sans-serif;
        }
        .ListofEvents {
            width: 100%;
            max-width: 1400px;
            margin: 0 auto;
            height: 100%;
            display: flex;
            flex-direction: column;
            align-items: center;
        }
        .postcont-comouter {
            display: -webkit-box;
            display: -ms-flexbox;
            display: flex;
            position: relative;
            padding: 16px;
            width: 66%;
            float: left;
        }
        .leftside-cont-outer {
            word-break: break-all;
            width: 70%;
            /*padding: 0 40px;*/
        }
        h1.post-title a {
            font-weight: 600;
            font-size: 1.125rem;
            line-height: 1.5rem;
            text-decoration: none;
            color: #39364f;
            -webkit-line-clamp: 3;
        }
        h1.post-title {
            word-break: break-word;
            margin: 0 0 10px;
        }
        .rightside-cont-outer {
            width: 220px;
        }
        .rightside-cont-outer a.post-img img {
            width: 100%;
            height: 100%;
            object-fit: cover;
        }
        span.post-date {
            color: #f05537;
            font-weight: 600;
            font-size: .875rem;
            line-height: 1.25rem;
        }
        .postcont-comouter:hover {
            -webkit-box-shadow: 0 4px 15px 0 rgb(40 44 53 / 6%), 0 2px 2px 0 rgb(40 44 53 / 8%);
            box-shadow: 0 4px 15px 0 rgb(40 44 53 / 6%), 0 2px 2px 0 rgb(40 44 53 / 8%);
            background-color: #fff;
            background-color: var(--eds-background,#fff);
            border-radius: 4px;
            z-index: 3;
        }
    </style>
</head>
<body>
    <div class="ListofEvents">
        <?php 
        $ListOfOrganization = Getting_ListOfCurrent_Organization();

        foreach ($ListOfOrganization->events as $Event_key => $Event_value) {
        
        $is_free = $Event_value->is_free;
        if($is_free == true){
            $is_free_check = 'free';
        } else {
            $is_free_check = 'no';
        }

        //Date formate change
        $Event_Date = date("d-m-Y | H:i", strtotime(trim($Event_value->start->local)));
        ?>
        <div class="postcont-comouter">
            <div class="leftside-cont-outer">
                <h1 class="post-title"><a href="<?php echo $Event_value->url; ?>" target="_blank"><?php echo $Event_value->name->text; ?></a></h1>
                <span class="post-date"><?php echo $Event_Date; ?></span>
                <p class="post-text"><?php echo $is_free_check; ?></p>
            </div>
            <div class="rightside-cont-outer">
                <a class="post-img" href="<?php echo $Event_value->url; ?>" target="_blank"><img src="<?php echo $Event_value->logo->original->url; ?>"></a>
            </div>
       </div>
       <?php } ?>
   </div>
</body>
</html>


<?php 

// $ListOfOrganizationjson = Getting_ListOfCurrent_Organization();

// $ListOfjasonArray = array();
// foreach ($ListOfOrganizationjson->events as $Event_key => $Event_value) {
//     $ListofProperty = new \stdClass();
//     $ListofProperty->name = $Event_value->name->text;
//     $ListofProperty->date = $Event_value->start->local;
//     $ListofProperty->is_free = $Event_value->is_free;
//     $ListofProperty->image = $Event_value->url;
//     $ListofProperty->thumbnail = $Event_value->url;
//     array_push($ListOfjasonArray, $ListofProperty);
// }

// json_encode($ListOfjasonArray);


function Getting_ListOfCurrent_Organization(){

    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://www.eventbriteapi.com/v3/organizations/185885570919/events/?time_filter=current_future",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "GET",
      CURLOPT_HTTPHEADER => array(
        "authorization: Bearer QADLMVGY3MRWODKRE52R",
      ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return json_decode($response);
    }

}