<?php 
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('max_execution_time', '0'); //300 seconds = 5 minutes
error_reporting(E_ALL);
ini_set('memory_limit', '-1');
ini_set('error_log', dirname(__FILE__)."/vettrak.log");

require 'config.php';

try {
    
    $options = array(
         'soap_version'=>SOAP_1_2,
         'exceptions'=>true,
         'trace'=>1,
         'cache_wsdl'=>WSDL_CACHE_NONE
    );
    $client = new SoapClient('https://sthservices.ozsoft.com.au/AHT_API/vt_api.asmx?WSDL', $options);

    $loginInfo = array('sUsername' => $Username, 'sPassword' => $Password);

    //Token get
    $Token_result = $client->ValidateUser($loginInfo);
    if($Token_result->ValidateUserResult->Status != 1)
    {
        // Failure - error message is in $Token_result->ValidateUserResult->StatusMessage
        die('Failure calling ValidateUser: ' . $Token_result->ValidateUserResult->StatusMessage);
    }
    $token = $Token_result->ValidateUserResult->Token;

    //Client 
    $Client_result = $client->ValidateClient($loginInfo);
    if($Client_result->ValidateClientResult->Status != 1)
    {
        // Failure - error message is in $Client_result->ValidateClientResult->StatusMessage
        die('Failure calling ValidateUser: ' . $Client_result->ValidateClientResult->StatusMessage);
    }
    $client_token = $Client_result->ValidateClientResult->Token;


    //Random Number Process
    if (file_exists($SaveNumberFile)) {

        $Get_SaveNumber = unserialize(file_get_contents($SaveNumberFile));

        if($Get_SaveNumber['number'] == $RandonNumber){

            $iWebe_ID = $Get_SaveNumber['increment_number']; //4150 //$Get_SaveNumber['increment_number'] //2054
            $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $iWebe_ID));

            if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID);
                //$InsertedData = Testincreamentnum();

                if($InsertedData == true){
                    $SaveNumberData = array(
                        'number' => $RandonNumber,
                        'increment_number' => $Get_SaveNumber['increment_number']+1
                    );
                    file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                }

            } else {
                echo "No data found";exit;
            }

        } else{

            if(!empty($RandonNumber)){
                $SaveNumberData = array(
                    'number' => $RandonNumber,
                    'increment_number' => $RandonNumber 
                );
                file_put_contents($SaveNumberFile, serialize($SaveNumberData));

                $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $RandonNumber));

                if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                    $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                    $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID);
                    //$InsertedData = Testincreamentnum();

                    if($InsertedData == true){
                        $SaveNumberData = array(
                            'number' => $RandonNumber,
                            'increment_number' => $RandonNumber+1
                        );
                        file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                    }
                } else {
                    echo "No data found, When number new";exit;
                }
            }
        }

    } else {

        if(!empty($RandonNumber)){
            $SaveNumberData = array(
                'number' => $RandonNumber,
                'increment_number' => $RandonNumber 
            );
            file_put_contents($SaveNumberFile, serialize($SaveNumberData));

            $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $RandonNumber));

            if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID);
                //$InsertedData = Testincreamentnum();

                if($InsertedData == true){
                    $SaveNumberData = array(
                        'number' => $RandonNumber,
                        'increment_number' => $RandonNumber+1
                    );
                    file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                }
            } else {
                echo "No data found, when file not exist";exit;
            }
        }
    }

exit;

} catch (Exception $e) {
    //print "something went wrong, caught yah! n";
    echo 'Message: ' .$e->getMessage();
}

//Function Start
function CreateAndUpdateHubspotData($hapi_key, $token, $client, $occurenceID){

    $GetEnrolmentsForOccurrence  = $client->GetEnrolmentsForOccurrence (array('sToken' => $token, 'iID' => $occurenceID ));
    $CollectHubspotEntryUpdate = array();
    $CollectHubspotEntryCreate = array();
    $num=0;
    if(isset($GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro)){

        if(is_array($GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro)){
            $GetClientEnroLastData = end($GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro);
            $ClientCode = $GetClientEnroLastData->Clie_Code;
        }else{
            $ClientCode = $GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro->Clie_Code;
        }
        //$ClientDummyCode = array('17689', '11835'); //change remove

        $QueryAdditionalDataArrayClintCode = array('token' => $token, 'entityName' => 'Client', 'filterCriteria' =>  array('FilterCriteria' => array('Field' => 'ClientCode', 'Operator' => 'Equals', 'Value' => $ClientCode )), 'returnFields' => array('ReturnField' => array( array('Field' => 'ClientCode'), array('Field' => 'Surname'), array('Field' => 'GivenName'), array('Field' => 'Email2'), array('Field' => 'PreferredName'), array('Field' => 'EmergencyPhone'), array('Field' => 'EmergencyMobile'), array('Field' => 'Citizenship'),  array('Field' => 'MarketingFlag'), array('Field' => 'DateCommenced'), array('Field' => 'DeltaNumber'), array('Field' => 'CreatedDate'), array('Field' => 'ModifiedDate'), )));

        $AdditionalData_result_clientcode = $client->QueryAdditionalData($QueryAdditionalDataArrayClintCode);

        $FamilyName = '';
        $GivenName = '';
        $Email2 = '';
        $PreferredName = '';
        $EmergencyCallValue = '';
        $EmergencyMobile = '';
        $CitizenshipValue = '';
        $MarketingFlagValue = '';
        $DateCommencedValue = '';
        $DeltaNumber = '';
        $CreatedDateValue = '';
        $ModifiedDate = '';
        if(isset($AdditionalData_result_clientcode->QueryAdditionalDataResult->Values->ArrayOfString->string)){
            if(is_array($AdditionalData_result_clientcode->QueryAdditionalDataResult->Values->ArrayOfString->string) && sizeof($AdditionalData_result_clientcode->QueryAdditionalDataResult->Values->ArrayOfString->string) >= 1 ){
                foreach($AdditionalData_result_clientcode->QueryAdditionalDataResult->Values->ArrayOfString as $ClientAdditionalData)
                {
                    $Client_ClientCode = isset($ClientAdditionalData[0]) ? $ClientAdditionalData[0] : ''; //yes
                    $FamilyName = isset($ClientAdditionalData[1]) ? $ClientAdditionalData[1] : '';
                    $GivenName = isset($ClientAdditionalData[2]) ? $ClientAdditionalData[2] : '';
                    $Email2 = isset($ClientAdditionalData[3]) ? $ClientAdditionalData[3] : '';
                    $PreferredName = isset($ClientAdditionalData[4]) ? $ClientAdditionalData[4] : '';
                    $EmergencyPhone = isset($ClientAdditionalData[5]) ? $ClientAdditionalData[5] : '';
                    $EmergencyMobile = isset($ClientAdditionalData[6]) ? $ClientAdditionalData[6] : '';
                    $Citizenship = isset($ClientAdditionalData[7]) ? $ClientAdditionalData[7] : '';
                    $MarketingFlag = isset($ClientAdditionalData[8]) ? $ClientAdditionalData[8] : '';
                    $DateCommenced = isset($ClientAdditionalData[9]) ? $ClientAdditionalData[9] : '';
                    if($DateCommenced != ''){
                        $DateCommencedValue = date("Y-m-d", strtotime(trim($DateCommenced)));
                    } else {
                        $DateCommencedValue = '';
                    }
                    $DeltaNumber = isset($ClientAdditionalData[10]) ? $ClientAdditionalData[10] : '';
                    $CreatedDate = isset($ClientAdditionalData[11]) ? $ClientAdditionalData[11] : '';
                    if($CreatedDate != ''){
                        $CreatedDateValue = date("Y-m-d", strtotime(trim($CreatedDate)));
                    } else {
                        $CreatedDateValue = '';
                    }
                    $ModifiedDate = isset($ClientAdditionalData[12]) ? $ClientAdditionalData[12] : '';

                    //$Emergency call detail
                    if($EmergencyPhone != ''){
                        $EmergencyCallValue = $EmergencyPhone;
                    } elseif ($EmergencyMobile != '') {
                        $EmergencyCallValue = $EmergencyMobile;
                    } else {
                        $EmergencyCallValue = '';
                    }

                    //Citizenship Value set
                    if($Citizenship == '0'){
                        $CitizenshipValue = 'Other';
                    } elseif ($Citizenship == '1') {
                        $CitizenshipValue = 'Australian Citizen';
                    } elseif ($Citizenship == '2') {
                        $CitizenshipValue = 'Overseas Resident';
                    } elseif ($Citizenship == '3') {
                        $CitizenshipValue = 'Permanent Resident of Australia';
                    } elseif ($Citizenship == '4') {
                        $CitizenshipValue = 'New Zealand Citizen';
                    } elseif ($Citizenship == '5') {
                        $CitizenshipValue = 'Visa Holder';
                    } elseif ($Citizenship == '6') {
                        $CitizenshipValue = 'Temporary Visa';
                    } else {
                        $CitizenshipValue = 'Other';
                    }

                    //MarketingFlag Value set
                    // if($MarketingFlag == '0'){
                    //     $MarketingFlagValue = true;
                    // } elseif ($MarketingFlag == '1') {
                    //     $MarketingFlagValue = false;
                    // }
                    if($MarketingFlag == '0'){
                        $MarketingFlagValue = 'Yes';
                    } elseif ($MarketingFlag == '1') {
                        $MarketingFlagValue = 'No';
                    } else {
                        $MarketingFlagValue = '';
                    }
                }
            }
        }

        if(!empty($ClientCode)){

            $GetAllClientDetails = $client->GetClientExtendedDetails(array('sToken' => $token, 'sClie_Code'=> $ClientCode, 'xsdStart'=>'2022-01-01T00:00:00','xsdEnd'=>'2022-01-01T00:00:00')); //get all details //change

            //EnrolledUnits //unit number but not match with 15406
            // if(isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->EnrolledUnits->TEnun)){
            //     if(is_array($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->EnrolledUnits->TEnun)){
            //         $EnrolledUnits = $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->EnrolledUnits->TEnun;
            //         $Unit_Number = $EnrolledUnits[0]->Unit_Code;
            //     } else {
            //         $EnrolledUnits = $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->EnrolledUnits->TEnun;
            //         $Unit_Number = $EnrolledUnits->Unit_Code;
            //     }
            // }

            //Enrolments Details
            if(isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->Enrolments->TClieEnro)){
                if(is_array($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->Enrolments->TClieEnro)){
                    $ProgrammeDetails = end($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->Enrolments->TClieEnro);
                    $EnrolmentID = isset($ProgrammeDetails->ID) ? $ProgrammeDetails->ID : '';
                    $Occurrence_StartDate = isset($ProgrammeDetails->StartDate) ? $ProgrammeDetails->StartDate : ''; 
                    $Occurrence_EndDate = isset($ProgrammeDetails->EndDate) ? $ProgrammeDetails->EndDate : '';
                    $Registration_Date = isset($ProgrammeDetails->DateOfEffect) ? $ProgrammeDetails->DateOfEffect : '';
                    $Qualification_Code = isset($ProgrammeDetails->Qual_Code) ? $ProgrammeDetails->Qual_Code : '';
                    $Qualification_Name = isset($ProgrammeDetails->Qual_Name) ? $ProgrammeDetails->Qual_Name : '';
                    $Programme_Name = $Qualification_Code.' '.$Qualification_Name; //yes
                    $Description = isset($ProgrammeDetails->Description) ? $ProgrammeDetails->Description : ''; //yes enrolid get
                    $Loca_Code = isset($ProgrammeDetails->Loca_Code) ? $ProgrammeDetails->Loca_Code : '';
                    $EmployerIdentifier = isset($ProgrammeDetails->EmployerIdentifier) ? $ProgrammeDetails->EmployerIdentifier : ''; //yes
                    $EmployerName = isset($ProgrammeDetails->EmployerName) ? $ProgrammeDetails->EmployerName : ''; //yes
                    $Amount = isset($ProgrammeDetails->Amount) ? $ProgrammeDetails->Amount : '';
                    $GST = isset($ProgrammeDetails->GST) ? $ProgrammeDetails->GST : '';
                    preg_match_all('!\d+!', $Description, $WebEnrolID);
                    $WebEnrolIDFinal = isset($WebEnrolID[0][0]) ? $WebEnrolID[0][0] : '';

                } else {
                    $ProgrammeDetails = $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->Enrolments->TClieEnro;

                    $EnrolmentID = isset($ProgrammeDetails->ID) ? $ProgrammeDetails->ID : '';
                    $Occurrence_StartDate = isset($ProgrammeDetails->StartDate) ? $ProgrammeDetails->StartDate : ''; 
                    $Occurrence_EndDate = isset($ProgrammeDetails->EndDate) ? $ProgrammeDetails->EndDate : '';
                    $Registration_Date = isset($ProgrammeDetails->DateOfEffect) ? $ProgrammeDetails->DateOfEffect : '';
                    $Qualification_Code = isset($ProgrammeDetails->Qual_Code) ? $ProgrammeDetails->Qual_Code : '';
                    $Qualification_Name = isset($ProgrammeDetails->Qual_Name) ? $ProgrammeDetails->Qual_Name : '';
                    $Programme_Name = $Qualification_Code.' '.$Qualification_Name; //yes
                    $Description = isset($ProgrammeDetails->Description) ? $ProgrammeDetails->Description : ''; //yes enrolid get
                    $Loca_Code = isset($ProgrammeDetails->Loca_Code) ? $ProgrammeDetails->Loca_Code : '';
                    $EmployerIdentifier = isset($ProgrammeDetails->EmployerIdentifier) ? $ProgrammeDetails->EmployerIdentifier : ''; //yes
                    $EmployerName = isset($ProgrammeDetails->EmployerName) ? $ProgrammeDetails->EmployerName : ''; //yes
                    $Amount = isset($ProgrammeDetails->Amount) ? $ProgrammeDetails->Amount : '';
                    $GST = isset($ProgrammeDetails->GST) ? $ProgrammeDetails->GST : '';
                    preg_match_all('!\d+!', $Description, $WebEnrolID);
                    $WebEnrolIDFinal = isset($WebEnrolID[0][0]) ? $WebEnrolID[0][0] : '';
                }

            }

            //Client Details

            $Clie_Surname = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Surname) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Surname : ''; //yes
            $Clie_Given = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Given) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Given : ''; //yes
            $Clie_Code = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Code) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Code : '';
            $Clie_Username = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Username) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Username : '';
            $Clie_DOB = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_DOB) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_DOB : ''; //yes
            $Clie_DOB_Convert = date("Y-m-d", strtotime(trim($Clie_DOB)));
            //UsualAddress/Residential Address Details
            $Building = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->Building) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->Building : ''; //yes
            $UnitDetails = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->UnitDetails) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->UnitDetails : ''; //yes
            $StreetNumber = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->StreetNumber) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->StreetNumber : ''; //yes
            $StreetName = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->StreetName) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->StreetName : ''; //yes
            $City = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->City) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->City : ''; //yes
            $State = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->State) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->State : ''; //yes
            $Postcode = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->Postcode) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->UsualAddress->Postcode : ''; //yes

            //Postal Address Details
            $Postal_Building = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->Building) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->Building : ''; //yes
            $Postal_UnitDetails = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->UnitDetails) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->UnitDetails : ''; //yes
            $Postal_StreetNumber = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->StreetNumber) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->StreetNumber : ''; //yes
            $Postal_StreetName = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->StreetName) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->StreetName : ''; //yes
            $Postal_City = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->City) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->City : ''; //yes
            $Postal_State = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->State) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->State : ''; //yes
            $Postal_Postcode = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->Postcode) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PostalAddress->Postcode : ''; //yes

            //Email
            $Clie_Email = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Email) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Email : ''; //yes
            //Phone Details
            $Clie_HomePhone = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_HomePhone) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_HomePhone : ''; //yes
            $Clie_WorkPhone = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_WorkPhone) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_WorkPhone : '';
            $Clie_MobilePhone = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_MobilePhone) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_MobilePhone : ''; //yes
            //Emergency Contact Details
            $Clie_EmergencyName = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_EmergencyName) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_EmergencyName : '';
            $Clie_EmergencyPhone = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_EmergencyPhone) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_EmergencyPhone : '';
            //Client Details
            $Clie_Title = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Title) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Clie_Title : '';
            $Gender = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Gender) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->Gender : ''; //yes
            //Employment Details
            $PositionName = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PositionName) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->PositionName : '';
            //USI Details
            $USI_Number = isset($GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->USI) ? $GetAllClientDetails->GetClientExtendedDetailsResult->ClieExtended->ClientDetail->USI : ''; //yes


            if(!empty(trim($Clie_Email))){

                if($Gender == 'F'){
                    $GenderFinal = 'Female';
                }else{
                    $GenderFinal = 'Male';
                }
                /*List Of Property*/
                $Properties_Main_Array = new \stdClass();
                $Properties_Sub = new \stdClass();
                $Properties_Sub->vettrak_client_id = $ClientCode; //change
                $Properties_Sub->lastname = $Clie_Surname;
                $Properties_Sub->firstname = $Clie_Given;
                $Properties_Sub->gender = $GenderFinal;
                $Properties_Sub->dob = isset($Clie_DOB_Convert) ? $Clie_DOB_Convert : '';
                $Properties_Sub->usi = $USI_Number;
                $Properties_Sub->unit_number = $UnitDetails;
                $Properties_Sub->building_name = $Building;
                $Properties_Sub->street_number = $StreetNumber;
                $Properties_Sub->address = $StreetName;
                $Properties_Sub->city = $City;
                $Properties_Sub->unit_number__postal_ = $Postal_UnitDetails;
                $Properties_Sub->building_name__postal_ = $Postal_Building;
                $Properties_Sub->street_number__postal_ = $Postal_StreetNumber;
                $Properties_Sub->street_address__postal_ = $Postal_StreetName;
                $Properties_Sub->suburb__postal_ = $Postal_City;
                $Properties_Sub->post_code__postal_ = $Postal_Postcode;
                $Properties_Sub->phone = $Clie_HomePhone;
                $Properties_Sub->mobilephone = $Clie_MobilePhone;
                $Properties_Sub->emergency_contact_name = $Clie_EmergencyName;
                // $Properties_Sub->emergency_contact_number = $Clie_EmergencyPhone;
                $Properties_Sub->emergency_contact_number = $EmergencyCallValue;
                $Properties_Sub->employer_name = isset($EmployerName) ? $EmployerName : '';
                $Properties_Sub->enrolment_id = isset($EnrolmentID) ? $EnrolmentID : '';

                $Properties_Sub->alternative_email_address = $Email2;
                $Properties_Sub->preferred_name = $PreferredName;
                $Properties_Sub->course_commencement_date = $DateCommencedValue;
                $Properties_Sub->delta_number = $DeltaNumber;
                $Properties_Sub->qualification_name = $Qualification_Name;

                $Properties_Sub->visa_citizenship_status = $CitizenshipValue;
                //$Properties_Sub->hs_email_optout_13986252 = $MarketingFlagValue;
                $Properties_Sub->marketingflag = $MarketingFlagValue;
                $Properties_Sub->vettrak_create_date = $CreatedDateValue;


                $Properties_Sub->vettrak_number = $ClientCode; //change
                $Properties_Sub->programme_name = $Programme_Name;
                //$Clie_Email_Dummy = 'example'.$num.'@gmail.com'; //change
                $Properties_Sub->email = $Clie_Email; //change
                /*List Of Property*/

                $FindEmailAlreadyExist = Search_Data_By_EmailID($hapi_key, $Clie_Email); //change

                if(isset($FindEmailAlreadyExist->results[0]->id)){
                    if(is_array($FindEmailAlreadyExist->results) && sizeof($FindEmailAlreadyExist->results) >= 1){
                        //Update Data
                        $Properties_Main_Array->id = $FindEmailAlreadyExist->results[0]->id;
                        $Properties_Main_Array->properties = $Properties_Sub;
                        array_push($CollectHubspotEntryUpdate, $Properties_Main_Array);

                    }
                } else {
                    //Create Data
                    $Properties_Main_Array->properties = $Properties_Sub;
                    array_push($CollectHubspotEntryCreate, $Properties_Main_Array);
                }

            }
        }
    
    }else{
        echo "No Enrolments Details Found";exit;
    }

    // echo "<pre>";
    // print_r($CollectHubspotEntryUpdate);
    // echo "Create below:";
    // print_r($CollectHubspotEntryCreate);
    // echo "</pre>";exit;
    
    $StatusMsg = false;
    //Create Hubspot data
    if(sizeof($CollectHubspotEntryCreate) >= 1){
        $Divided_CollectHubspotEntryCreate = count($CollectHubspotEntryCreate) / 1;
        $Divided_CollectHubspotEntryCreate_Final = array_chunk($CollectHubspotEntryCreate, ceil(count($CollectHubspotEntryCreate) / $Divided_CollectHubspotEntryCreate));
        foreach ($Divided_CollectHubspotEntryCreate_Final as $Divided_CollectHubspotEntryCreate_Final_Key => $Divided_CollectHubspotEntryCreate_Final_Value) {
            // $Divided_National_Array_Final_Value_Reverse = array_reverse($Divided_National_Array_Final_Value);
            // $Divided_National_Array_Final_Value_Final_Unique = array_unique($Divided_National_Array_Final_Value_Reverse, SORT_REGULAR);
            //$Divided_National_Array_Final_Value_Final_Unique = NationalContactUniqeArray($Divided_National_Array_Final_Value);
            $CollectHubspotEntryCreate_Main_Object_Create = new \stdClass();
            $CollectHubspotEntryCreate_Main_Object_Create->inputs = $Divided_CollectHubspotEntryCreate_Final_Value;
            $Final_CollectHubspotEntryCreate_Object = json_encode($CollectHubspotEntryCreate_Main_Object_Create);
            $ContactCreateRes = json_decode(Create_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryCreate_Object));
            $ContactCreateRes_Encode = json_encode(Create_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryCreate_Object));
            if($ContactCreateRes->status == 'COMPLETE'){
                echo "Contact Create Status: ".$ContactCreateRes->status;
                //error_log("Created Data: ".$ContactCreateRes_Encode." \n", 3, "logfile.log");
                $StatusMsg = true;
            } else {
                echo json_encode($ContactCreateRes);
                $StatusMsg = false;
            }
       }
    }


    //Update Contact Data
    if(sizeof($CollectHubspotEntryUpdate) >= 1){
        $CollectHubspotEntryUpdate_Array = count($CollectHubspotEntryUpdate) / 10;
        $CollectHubspotEntryUpdate_Array_Final = array_chunk($CollectHubspotEntryUpdate, ceil(count($CollectHubspotEntryUpdate) / $CollectHubspotEntryUpdate_Array));
        foreach ($CollectHubspotEntryUpdate_Array_Final as $CollectHubspotEntryUpdate_Final_Key => $CollectHubspotEntryUpdate_Final_Value) {

            $CollectHubspotEntryUpdate_Main_Object_Update = new \stdClass();
            $CollectHubspotEntryUpdate_Main_Object_Update->inputs = $CollectHubspotEntryUpdate_Final_Value;
            $Final_CollectHubspotEntryUpdate_Object = json_encode($CollectHubspotEntryUpdate_Main_Object_Update);
            $ContactUpdateRes = json_decode(Update_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryUpdate_Object));
            if($ContactUpdateRes->status == 'COMPLETE'){
                echo "Contact Update Status: ".$ContactUpdateRes->status;
                $StatusMsg = true;
            } else {
                echo json_encode($ContactUpdateRes);
                $StatusMsg = false;
            }
        }
    }

    // $HubsporResponse = InsertDataIntoHubspot($CollectHubspotEntryEncode);
    if($StatusMsg == true){
        return true;
    }else{
        return false;
    }

}


//Create Contact Data Using Batch
function Create_Batch_Hubspot_Contact_Data($hapi_key, $json_data){
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/batch/create?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $json_data,
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return $response;
    }
}


//Update Contact Data Using Batch
function Update_Batch_Hubspot_Contact_Data($hapi_key, $json_data){
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/batch/update?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $json_data,
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));
    $response = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return $response;
    }
}

//Find Data existing in hubspot
function Search_Data_By_EmailID($hapi_key, $emailid){

    $FilterGroups_Array = array();
    $Filters_Sub_Array = array();
    $Properties_Array = array('firstname', 'lastname', 'email');
    $Filter_Sub = new \stdClass();
    $Filter_Sub->value = $emailid;
    $Filter_Sub->propertyName = "email";
    $Filter_Sub->operator = "EQ";
    array_push($Filters_Sub_Array, $Filter_Sub);
    $FilterGroups_Sub_Obj = new \stdClass();
    $FilterGroups_Sub_Obj->filters = $Filters_Sub_Array;

    $Filters_Sub_Two_Array = array();
    $Filter_Sub_Two = new \stdClass();
    $Filter_Sub_Two->value = $emailid;
    $Filter_Sub_Two->propertyName = "hs_additional_emails";
    $Filter_Sub_Two->operator = "EQ";
    array_push($Filters_Sub_Two_Array, $Filter_Sub_Two);
    $FilterGroups_Sub_Two_Obj = new \stdClass();
    $FilterGroups_Sub_Two_Obj->filters = $Filters_Sub_Two_Array;

    array_push($FilterGroups_Array, $FilterGroups_Sub_Obj);
    array_push($FilterGroups_Array, $FilterGroups_Sub_Two_Obj);
    $FilterGroups_Main_obj = new \stdClass();
    $FilterGroups_Main_obj->filterGroups = $FilterGroups_Array;
    $FilterGroups_Main_obj->properties = $Properties_Array;

    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/search?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => json_encode($FilterGroups_Main_obj),
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));
    $response = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return json_decode($response);
    }
}