<?php 
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('max_execution_time', '0'); //300 seconds = 5 minutes
error_reporting(E_ALL);
ini_set('memory_limit', '-1');
ini_set('error_log', dirname(__FILE__)."/vettrak.log");

require 'config.php';

try {
    
    $options = array(
         'soap_version'=>SOAP_1_2,
         'exceptions'=>true,
         'trace'=>1,
         'cache_wsdl'=>WSDL_CACHE_NONE
    );
    $client = new SoapClient('https://sthservices.ozsoft.com.au/AHT_API/vt_api.asmx?WSDL', $options);

    $loginInfo = array('sUsername' => $Username, 'sPassword' => $Password);

    //Token get
    $Token_result = $client->ValidateUser($loginInfo);
    if($Token_result->ValidateUserResult->Status != 1)
    {
        // Failure - error message is in $Token_result->ValidateUserResult->StatusMessage
        die('Failure calling ValidateUser: ' . $Token_result->ValidateUserResult->StatusMessage);
    }
    $token = $Token_result->ValidateUserResult->Token;

    //Client 
    $Client_result = $client->ValidateClient($loginInfo);
    if($Client_result->ValidateClientResult->Status != 1)
    {
        // Failure - error message is in $Client_result->ValidateClientResult->StatusMessage
        die('Failure calling ValidateUser: ' . $Client_result->ValidateClientResult->StatusMessage);
    }
    $client_token = $Client_result->ValidateClientResult->Token;


    //Random Number Process
    if (file_exists($SaveNumberFile)) {

        $Get_SaveNumber = unserialize(file_get_contents($SaveNumberFile));

        if($Get_SaveNumber['number'] == $RandonNumber){

            $iWebe_ID = $Get_SaveNumber['increment_number']; //4150 //$Get_SaveNumber['increment_number'] //2054
            $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $iWebe_ID));

            if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID, $iWebe_ID);
                //$InsertedData = Testincreamentnum();

                if($InsertedData == true){
                    $SaveNumberData = array(
                        'number' => $RandonNumber,
                        'increment_number' => $Get_SaveNumber['increment_number']+1
                    );
                    file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                }

            } else {
                echo "No data found";exit;
            }

        } else{

            if(!empty($RandonNumber)){
                $SaveNumberData = array(
                    'number' => $RandonNumber,
                    'increment_number' => $RandonNumber 
                );
                file_put_contents($SaveNumberFile, serialize($SaveNumberData));

                $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $RandonNumber));

                if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                    $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                    $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID, $RandonNumber);
                    //$InsertedData = Testincreamentnum();

                    if($InsertedData == true){
                        $SaveNumberData = array(
                            'number' => $RandonNumber,
                            'increment_number' => $RandonNumber+1
                        );
                        file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                    }
                } else {
                    echo "No data found, When number new";exit;
                }
            }
        }

    } else {

        if(!empty($RandonNumber)){
            $SaveNumberData = array(
                'number' => $RandonNumber,
                'increment_number' => $RandonNumber 
            );
            file_put_contents($SaveNumberFile, serialize($SaveNumberData));

            $WebEnrolmentResult = $client->GetWebEnrolment(array('sToken' => $token, 'iWebe_ID' => $RandonNumber));

            if(isset($WebEnrolmentResult->GetWebEnrolmentResult->Webe) && $WebEnrolmentResult->GetWebEnrolmentResult->Auth->Status == 1){
                $Occu_ID = $WebEnrolmentResult->GetWebEnrolmentResult->Webe->Occu_ID;
                $InsertedData = CreateAndUpdateHubspotData($hapi_key, $token, $client, $Occu_ID, $RandonNumber);
                //$InsertedData = Testincreamentnum();

                if($InsertedData == true){
                    $SaveNumberData = array(
                        'number' => $RandonNumber,
                        'increment_number' => $RandonNumber+1
                    );
                    file_put_contents($SaveNumberFile, serialize($SaveNumberData));
                }
            } else {
                echo "No data found, when file not exist";exit;
            }
        }
    }

exit;

} catch (Exception $e) {
    //print "something went wrong, caught yah! n";
    echo 'Message: ' .$e->getMessage();
}

//Function Start
function CreateAndUpdateHubspotData($hapi_key, $token, $client, $occurenceID, $WebID){

    //$GetEnrolmentsForOccurrence  = $client->GetEnrolmentsForOccurrence (array('sToken' => $token, 'iID' => $occurenceID ));
    $GetOccurrenceDetails = $client->GetOccurrenceDetails (array('sToken' => $token, 'iOccu_ID' => $occurenceID ));
    $GetWebClientsForOccurrence  = $client->GetWebClientsForOccurrence (array('sToken' => $token, 'iOccu_ID' => $occurenceID ));

    // echo "<pre>";
    // print_r($GetOccurrenceDetails);
    // echo "</pre>";
    $CollectHubspotEntryUpdate = array();
    $CollectHubspotEntryCreate = array();
    $num=0;
    if(isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl)){

        //Extra details for class
        // if(is_array($GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro)){
        //     $GetClientEnroLastData = end($GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro);
        //     $ClieEnro_StartDate = $GetClientEnroLastData->StartDate;
        //     $ClieEnro_StartDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_StartDate)));
        //     $ClieEnro_EndDate = $GetClientEnroLastData->EndDate;
        //     $ClieEnro_EndDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_EndDate)));
        //     $ClieEnro_Qual_Code = $GetClientEnroLastData->Qual_Code;
        //     $ClieEnro_Qual_Name = $GetClientEnroLastData->Qual_Name;
        // }else{
        //     $ClieEnro_StartDate = $GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro->StartDate;
        //     $ClieEnro_StartDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_StartDate)));
        //     $ClieEnro_EndDate = $GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro->EndDate;
        //     $ClieEnro_EndDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_EndDate)));
        //     $ClieEnro_Qual_Code = $GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro->Qual_Code;
        //     $ClieEnro_Qual_Name = $GetEnrolmentsForOccurrence->GetEnrolmentsForOccurrenceResult->ClieEnroList->TClieEnro->Qual_Name;
        // }

        if(isset($GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu)){
            $ClieEnro_StartDate = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->StartDate;
            $ClieEnro_StartDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_StartDate)));
            $ClieEnro_EndDate = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->EndDate;
            $ClieEnro_EndDate_Change = date("Y-m-d", strtotime(trim($ClieEnro_EndDate)));
            $ClieEnro_Qual_Code = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->Qual_Code;
            $ClieEnro_Qual_Name = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->Qual_Name;
            $ClieEnro_Prog_Code = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->Prog_Code;
            $ClieEnro_Prog_Name = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->Prog_Name;
            $ClieEnro_Loca_Code = $GetOccurrenceDetails->GetOccurrenceDetailsResult->Occu->Loca_Code;
        }

        if(is_array($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl)){

            foreach ($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl as $key => $Occ_value) {
                if($Occ_value->Webe_ID == $WebID){

                    $Surname = isset($Occ_value->Surname) ? $Occ_value->Surname : ''; //yes
                    $Given = isset($Occ_value->Given) ? $Occ_value->Given : ''; //yes
                    $Title = isset($Occ_value->Title) ? $Occ_value->Title : ''; //yes
                    $DOB = isset($Occ_value->DOB) ? $Occ_value->DOB : ''; //yes
                    $Clie_DOB_Convert = date("Y-m-d", strtotime(trim($DOB)));
                    $Gender = isset($Occ_value->Gender) ? $Occ_value->Gender : ''; //yes
                    if($Gender == 'F'){
                        $GenderFinal = 'Female';
                    }else{
                        $GenderFinal = 'Male';
                    }

                    $Addr = isset($Occ_value->Addr) ? $Occ_value->Addr : ''; //yes
                    $City = isset($Occ_value->City) ? $Occ_value->City : ''; //yes
                    $PCode = isset($Occ_value->PCode) ? $Occ_value->PCode : ''; //yes
                    $Stat_ShortName = isset($Occ_value->Stat_ShortName) ? $Occ_value->Stat_ShortName : ''; //yes
                    $HomePhone = isset($Occ_value->HomePhone) ? $Occ_value->HomePhone : ''; //yes
                    $WorkPhone = isset($Occ_value->WorkPhone) ? $Occ_value->WorkPhone : ''; //yes
                    $Mobile = isset($Occ_value->Mobile) ? $Occ_value->Mobile : ''; //yes
                    $Email = isset($Occ_value->Email) ? $Occ_value->Email : ''; //yes
                    $EmergencyName = isset($Occ_value->EmergencyName) ? $Occ_value->EmergencyName : ''; //yes
                    $EmergencyMobile = isset($Occ_value->EmergencyMobile) ? $Occ_value->EmergencyMobile : ''; //yes
                    $PostalAddr = isset($Occ_value->PostalAddr) ? $Occ_value->PostalAddr : ''; //yes
                    $PostalCity = isset($Occ_value->PostalCity) ? $Occ_value->PostalCity : ''; //yes
                    $PostalPostcode = isset($Occ_value->PostalPostcode) ? $Occ_value->PostalPostcode : ''; //yes
                    $PostalStat_ShortName = isset($Occ_value->PostalStat_ShortName) ? $Occ_value->PostalStat_ShortName : ''; //yes
                    $UsualAddress_Building = isset($Occ_value->UsualAddress->Building) ? $Occ_value->UsualAddress->Building : ''; //yes
                    $UsualAddress_UnitDetails = isset($Occ_value->UsualAddress->UnitDetails) ? $Occ_value->UsualAddress->UnitDetails : ''; //yes
                    $UsualAddress_StreetNumber = isset($Occ_value->UsualAddress->StreetNumber) ? $Occ_value->UsualAddress->StreetNumber : ''; //yes
                    $UsualAddress_StreetName = isset($Occ_value->UsualAddress->StreetName) ? $Occ_value->UsualAddress->StreetName : ''; //yes
                    $UsualAddress_City = isset($Occ_value->UsualAddress->City) ? $Occ_value->UsualAddress->City : ''; //yes
                    $UsualAddress_State = isset($Occ_value->UsualAddress->State) ? $Occ_value->UsualAddress->State : ''; //yes
                    $UsualAddress_Postcode = isset($Occ_value->UsualAddress->Postcode) ? $Occ_value->UsualAddress->Postcode : ''; //yes
                    $PostalAddress_Building = isset($Occ_value->UsualAddress->Building) ? $Occ_value->UsualAddress->Building : ''; //yes
                    $PostalAddress_UnitDetails = isset($Occ_value->UsualAddress->UnitDetails) ? $Occ_value->UsualAddress->UnitDetails : ''; //yes
                    $PostalAddress_StreetNumber = isset($Occ_value->UsualAddress->StreetNumber) ? $Occ_value->UsualAddress->StreetNumber : ''; //yes
                    $PostalAddress_StreetName = isset($Occ_value->UsualAddress->StreetName) ? $Occ_value->UsualAddress->StreetName : ''; //yes
                    $PostalAddress_City = isset($Occ_value->UsualAddress->City) ? $Occ_value->UsualAddress->City : ''; //yes
                    $PostalAddress_State = isset($Occ_value->UsualAddress->State) ? $Occ_value->UsualAddress->State : ''; //yes
                    $PostalAddress_Postcode = isset($Occ_value->UsualAddress->Postcode) ? $Occ_value->UsualAddress->Postcode : ''; //yes
                    $USI = isset($Occ_value->USI) ? $Occ_value->USI : ''; //yes
                    $SurveyContactStatusCode = isset($Occ_value->SurveyContactStatusCode) ? $Occ_value->SurveyContactStatusCode : ''; //yes


                    if(!empty(trim($Email))){

                        $Properties_Main_Array = new \stdClass();
                        $Properties_Sub = new \stdClass();
                        $Properties_Sub->vettrak_client_id = $WebID; //change
                        
                        $Properties_Sub->lastname = $Surname;
                        $Properties_Sub->firstname = $Given;
                        $Properties_Sub->gender = $GenderFinal;
                        $Properties_Sub->dob = isset($Clie_DOB_Convert) ? $Clie_DOB_Convert : '';
                        $Properties_Sub->usi = $USI;
                        $Properties_Sub->unit_number = $UsualAddress_UnitDetails;
                        $Properties_Sub->building_name = $UsualAddress_Building;
                        $Properties_Sub->street_number = $UsualAddress_StreetNumber;
                        $Properties_Sub->address = $UsualAddress_StreetName;
                        $Properties_Sub->city = $UsualAddress_City;

                        $Properties_Sub->unit_number__postal_ = $PostalAddress_UnitDetails;
                        $Properties_Sub->building_name__postal_ = $PostalAddress_Building;
                        $Properties_Sub->street_number__postal_ = $PostalAddress_StreetNumber;
                        $Properties_Sub->street_address__postal_ = $PostalAddress_StreetName;
                        $Properties_Sub->suburb__postal_ = $PostalAddress_City;
                        $Properties_Sub->post_code__postal_ = $PostalAddress_Postcode;
                        $Properties_Sub->phone = $HomePhone;
                        $Properties_Sub->mobilephone = $Mobile;
                        $Properties_Sub->emergency_contact_name = $EmergencyName;

                        $Properties_Sub->emergency_contact_number = $EmergencyMobile;
                        $Properties_Sub->vettrak_number = $WebID; //change
                        //$Clie_Email_Dummy = 'example'.$num.'@gmail.com'; //change
                        $Properties_Sub->email = $Email; //change

                        //Class Details
                        $Properties_Sub->qualification_startdate = $ClieEnro_StartDate_Change;
                        $Properties_Sub->qualification_enddate = $ClieEnro_EndDate_Change;
                        $Properties_Sub->qualification_code = $ClieEnro_Qual_Code;
                        $Properties_Sub->qualification_name = $ClieEnro_Qual_Name;
                        $Properties_Sub->programme_name = $ClieEnro_Prog_Name;
                        $Properties_Sub->location_code = $ClieEnro_Loca_Code;

                        $FindEmailAlreadyExist = Search_Data_By_EmailID($hapi_key, $Email); //change

                        if(isset($FindEmailAlreadyExist->results[0]->id)){
                            if(is_array($FindEmailAlreadyExist->results) && sizeof($FindEmailAlreadyExist->results) >= 1){
                                //Update Data
                                $Properties_Main_Array->id = $FindEmailAlreadyExist->results[0]->id;
                                $Properties_Main_Array->properties = $Properties_Sub;
                                array_push($CollectHubspotEntryUpdate, $Properties_Main_Array);

                            }
                        } else {
                            //Create Data
                            $Properties_Main_Array->properties = $Properties_Sub;
                            array_push($CollectHubspotEntryCreate, $Properties_Main_Array);
                        }
                    }
                    
                }
            }

        }else{

            $Surname = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Surname) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Surname : ''; //yes
            $Given = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Given) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Given : ''; //yes
            $Title = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Title) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Title : ''; //yes
            $DOB = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->DOB) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->DOB : ''; //yes
            $Clie_DOB_Convert = date("Y-m-d", strtotime(trim($DOB)));
            $Gender = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Gender) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Gender : ''; //yes
            if($Gender == 'F'){
                $GenderFinal = 'Female';
            }else{
                $GenderFinal = 'Male';
            }

            $Addr = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Addr) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Addr : ''; //yes
            $City = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->City) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->City : ''; //yes
            $PCode = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PCode) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PCode : ''; //yes
            $Stat_ShortName = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Stat_ShortName) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Stat_ShortName : ''; //yes
            $HomePhone = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->HomePhone) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->HomePhone : ''; //yes
            $WorkPhone = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->WorkPhone) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->WorkPhone : ''; //yes
            $Mobile = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Mobile) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Mobile : ''; //yes
            $Email = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Email) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->Email : ''; //yes
            $EmergencyName = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->EmergencyName) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->EmergencyName : ''; //yes
            $EmergencyMobile = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->EmergencyMobile) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->EmergencyMobile : ''; //yes
            $PostalAddr = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalAddr) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalAddr : ''; //yes
            $PostalCity = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalCity) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalCity : ''; //yes
            $PostalPostcode = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalPostcode) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalPostcode : ''; //yes
            $PostalStat_ShortName = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalStat_ShortName) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->PostalStat_ShortName : ''; //yes
            $UsualAddress_Building = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Building) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Building : ''; //yes
            $UsualAddress_UnitDetails = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->UnitDetails) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->UnitDetails : ''; //yes
            $UsualAddress_StreetNumber = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetNumber) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetNumber : ''; //yes
            $UsualAddress_StreetName = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetName) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetName : ''; //yes
            $UsualAddress_City = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->City) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->City : ''; //yes
            $UsualAddress_State = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->State) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->State : ''; //yes
            $UsualAddress_Postcode = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Postcode) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Postcode : ''; //yes
            $PostalAddress_Building = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Building) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Building : ''; //yes
            $PostalAddress_UnitDetails = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->UnitDetails) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->UnitDetails : ''; //yes
            $PostalAddress_StreetNumber = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetNumber) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetNumber : ''; //yes
            $PostalAddress_StreetName = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetName) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->StreetName : ''; //yes
            $PostalAddress_City = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->City) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->City : ''; //yes
            $PostalAddress_State = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->State) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->State : ''; //yes
            $PostalAddress_Postcode = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Postcode) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->UsualAddress->Postcode : ''; //yes
            $USI = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->USI) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->USI : ''; //yes
            $SurveyContactStatusCode = isset($GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->SurveyContactStatusCode) ? $GetWebClientsForOccurrence->GetWebClientsForOccurrenceResult->WeclList->TWecl->SurveyContactStatusCode : ''; //yes


            if(!empty(trim($Email))){

                $Properties_Main_Array = new \stdClass();
                $Properties_Sub = new \stdClass();
                $Properties_Sub->vettrak_client_id = $WebID; //change
                
                $Properties_Sub->lastname = $Surname;
                $Properties_Sub->firstname = $Given;
                $Properties_Sub->gender = $GenderFinal;
                $Properties_Sub->dob = isset($Clie_DOB_Convert) ? $Clie_DOB_Convert : '';
                $Properties_Sub->usi = $USI;
                $Properties_Sub->unit_number = $UsualAddress_UnitDetails;
                $Properties_Sub->building_name = $UsualAddress_Building;
                $Properties_Sub->street_number = $UsualAddress_StreetNumber;
                $Properties_Sub->address = $UsualAddress_StreetName;
                $Properties_Sub->city = $UsualAddress_City;

                $Properties_Sub->unit_number__postal_ = $PostalAddress_UnitDetails;
                $Properties_Sub->building_name__postal_ = $PostalAddress_Building;
                $Properties_Sub->street_number__postal_ = $PostalAddress_StreetNumber;
                $Properties_Sub->street_address__postal_ = $PostalAddress_StreetName;
                $Properties_Sub->suburb__postal_ = $PostalAddress_City;
                $Properties_Sub->post_code__postal_ = $PostalAddress_Postcode;
                $Properties_Sub->phone = $HomePhone;
                $Properties_Sub->mobilephone = $Mobile;
                $Properties_Sub->emergency_contact_name = $EmergencyName;

                $Properties_Sub->emergency_contact_number = $EmergencyMobile;
                $Properties_Sub->vettrak_number = $WebID; //change
                //$Clie_Email_Dummy = 'example'.$num.'@gmail.com'; //change
                $Properties_Sub->email = $Email; //change

                //Class Details
                $Properties_Sub->qualification_startdate = $ClieEnro_StartDate_Change;
                $Properties_Sub->qualification_enddate = $ClieEnro_EndDate_Change;
                $Properties_Sub->qualification_code = $ClieEnro_Qual_Code;
                $Properties_Sub->qualification_name = $ClieEnro_Qual_Name;
                $Properties_Sub->programme_name = $ClieEnro_Prog_Name;
                $Properties_Sub->location_code = $ClieEnro_Loca_Code;

                $FindEmailAlreadyExist = Search_Data_By_EmailID($hapi_key, $Email); //change

                if(isset($FindEmailAlreadyExist->results[0]->id)){
                    if(is_array($FindEmailAlreadyExist->results) && sizeof($FindEmailAlreadyExist->results) >= 1){
                        //Update Data
                        $Properties_Main_Array->id = $FindEmailAlreadyExist->results[0]->id;
                        $Properties_Main_Array->properties = $Properties_Sub;
                        array_push($CollectHubspotEntryUpdate, $Properties_Main_Array);

                    }
                } else {
                    //Create Data
                    $Properties_Main_Array->properties = $Properties_Sub;
                    array_push($CollectHubspotEntryCreate, $Properties_Main_Array);
                }
            }

        }

    }else{
        echo "No Enrolments Details Found";exit;
    }

    // echo "<pre>";
    // print_r($CollectHubspotEntryUpdate);
    // echo "Create below:";
    // print_r($CollectHubspotEntryCreate);
    // echo "</pre>";exit;
    
    $StatusMsg = false;
    //Create Hubspot data
    if(sizeof($CollectHubspotEntryCreate) >= 1){
        $Divided_CollectHubspotEntryCreate = count($CollectHubspotEntryCreate) / 1;
        $Divided_CollectHubspotEntryCreate_Final = array_chunk($CollectHubspotEntryCreate, ceil(count($CollectHubspotEntryCreate) / $Divided_CollectHubspotEntryCreate));
        foreach ($Divided_CollectHubspotEntryCreate_Final as $Divided_CollectHubspotEntryCreate_Final_Key => $Divided_CollectHubspotEntryCreate_Final_Value) {
            // $Divided_National_Array_Final_Value_Reverse = array_reverse($Divided_National_Array_Final_Value);
            // $Divided_National_Array_Final_Value_Final_Unique = array_unique($Divided_National_Array_Final_Value_Reverse, SORT_REGULAR);
            //$Divided_National_Array_Final_Value_Final_Unique = NationalContactUniqeArray($Divided_National_Array_Final_Value);
            $CollectHubspotEntryCreate_Main_Object_Create = new \stdClass();
            $CollectHubspotEntryCreate_Main_Object_Create->inputs = $Divided_CollectHubspotEntryCreate_Final_Value;
            $Final_CollectHubspotEntryCreate_Object = json_encode($CollectHubspotEntryCreate_Main_Object_Create);
            $ContactCreateRes = json_decode(Create_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryCreate_Object));
            $ContactCreateRes_Encode = json_encode(Create_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryCreate_Object));
            if($ContactCreateRes->status == 'COMPLETE'){
                echo "Contact Create Status: ".$ContactCreateRes->status;
                //error_log("Created Data: ".$ContactCreateRes_Encode." \n", 3, "logfile.log");
                $StatusMsg = true;
            } else {
                echo json_encode($ContactCreateRes);
                $StatusMsg = false;
            }
       }
    }


    //Update Contact Data
    if(sizeof($CollectHubspotEntryUpdate) >= 1){
        $CollectHubspotEntryUpdate_Array = count($CollectHubspotEntryUpdate) / 10;
        $CollectHubspotEntryUpdate_Array_Final = array_chunk($CollectHubspotEntryUpdate, ceil(count($CollectHubspotEntryUpdate) / $CollectHubspotEntryUpdate_Array));
        foreach ($CollectHubspotEntryUpdate_Array_Final as $CollectHubspotEntryUpdate_Final_Key => $CollectHubspotEntryUpdate_Final_Value) {

            $CollectHubspotEntryUpdate_Main_Object_Update = new \stdClass();
            $CollectHubspotEntryUpdate_Main_Object_Update->inputs = $CollectHubspotEntryUpdate_Final_Value;
            $Final_CollectHubspotEntryUpdate_Object = json_encode($CollectHubspotEntryUpdate_Main_Object_Update);
            $ContactUpdateRes = json_decode(Update_Batch_Hubspot_Contact_Data($hapi_key, $Final_CollectHubspotEntryUpdate_Object));
            if($ContactUpdateRes->status == 'COMPLETE'){
                echo "Contact Update Status: ".$ContactUpdateRes->status;
                $StatusMsg = true;
            } else {
                echo json_encode($ContactUpdateRes);
                $StatusMsg = false;
            }
        }
    }

    // $HubsporResponse = InsertDataIntoHubspot($CollectHubspotEntryEncode);
    if($StatusMsg == true){
        return true;
    }else{
        return false;
    }

}


//Create Contact Data Using Batch
function Create_Batch_Hubspot_Contact_Data($hapi_key, $json_data){
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/batch/create?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $json_data,
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return $response;
    }
}


//Update Contact Data Using Batch
function Update_Batch_Hubspot_Contact_Data($hapi_key, $json_data){
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/batch/update?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $json_data,
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));
    $response = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return $response;
    }
}

//Find Data existing in hubspot
function Search_Data_By_EmailID($hapi_key, $emailid){

    $FilterGroups_Array = array();
    $Filters_Sub_Array = array();
    $Properties_Array = array('firstname', 'lastname', 'email');
    $Filter_Sub = new \stdClass();
    $Filter_Sub->value = $emailid;
    $Filter_Sub->propertyName = "email";
    $Filter_Sub->operator = "EQ";
    array_push($Filters_Sub_Array, $Filter_Sub);
    $FilterGroups_Sub_Obj = new \stdClass();
    $FilterGroups_Sub_Obj->filters = $Filters_Sub_Array;

    $Filters_Sub_Two_Array = array();
    $Filter_Sub_Two = new \stdClass();
    $Filter_Sub_Two->value = $emailid;
    $Filter_Sub_Two->propertyName = "hs_additional_emails";
    $Filter_Sub_Two->operator = "EQ";
    array_push($Filters_Sub_Two_Array, $Filter_Sub_Two);
    $FilterGroups_Sub_Two_Obj = new \stdClass();
    $FilterGroups_Sub_Two_Obj->filters = $Filters_Sub_Two_Array;

    array_push($FilterGroups_Array, $FilterGroups_Sub_Obj);
    array_push($FilterGroups_Array, $FilterGroups_Sub_Two_Obj);
    $FilterGroups_Main_obj = new \stdClass();
    $FilterGroups_Main_obj->filterGroups = $FilterGroups_Array;
    $FilterGroups_Main_obj->properties = $Properties_Array;

    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts/search?hapikey=$hapi_key",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => json_encode($FilterGroups_Main_obj),
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
      ),
    ));
    $response = curl_exec($curl);
    $err = curl_error($curl);
    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return json_decode($response);
    }
}