<?php

function authorize_code_call($client_id, $client_secret, $current_redirect_link, $authorize_code){

	$post_form_data = 'grant_type=authorization_code&client_id='.$client_id.'&client_secret='.$client_secret.'&redirect_uri='.$current_redirect_link.'&code='.$authorize_code.'';
	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => "https://api.hubapi.com/oauth/v1/token",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "POST",
	  CURLOPT_POSTFIELDS => $post_form_data,
	  CURLOPT_HTTPHEADER => array(
	    "content-type: application/x-www-form-urlencoded",
	  ),
	));

	$response = curl_exec($curl);
	$err = curl_error($curl);
	curl_close($curl);

	return json_decode($response);
}

function refresh_token_call($client_id, $client_secret, $current_redirect_link, $refresh_token){

	$post_form_data = 'grant_type=refresh_token&client_id='.$client_id.'&client_secret='.$client_secret.'&redirect_uri='.$current_redirect_link.'&refresh_token='.$refresh_token.'';

	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => "https://api.hubapi.com/oauth/v1/token",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "POST",
	  CURLOPT_POSTFIELDS => $post_form_data,
	  CURLOPT_HTTPHEADER => array(
	    "content-type: application/x-www-form-urlencoded",
	  ),
	));

	$response = curl_exec($curl);
	$err = curl_error($curl);
	curl_close($curl);

	return json_decode($response);
}

function refresh_token_in_file($Token_File, $client_id, $client_secret, $current_redirect_link){

	$accesstoken_details = unserialize(file_get_contents($Token_File));
	$refresh_token = $accesstoken_details->refresh_token;

	$refresh_token_res = refresh_token_call($client_id, $client_secret, $current_redirect_link, $refresh_token);
	if(isset($refresh_token_res->status) && $refresh_token_res->status == 'BAD_REFRESH_TOKEN'){
		echo $refresh_token_res->message;exit;
	}
	if($refresh_token_res->access_token != ''){
		file_put_contents($Token_File, serialize($refresh_token_res));
		return true;
	} else {
		return false;
	}
}


//Contact Property
$property_list = "&properties=firstname";
$property_list .= "&properties=lastname";
$property_list .= "&properties=email";
$property_list .= "&properties=phone";
$property_list .= "&properties=company";
$property_list .= "&properties=website";
$property_list .= "&properties=comment";

function Get_contact_list_by_accesstoken($access_token, $Token_File, $client_id, $client_secret, $current_redirect_link, $property_list){

	$curl = curl_init();
	curl_setopt_array($curl, array(
	  CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts?limit=10&archived=false$property_list",
	  CURLOPT_RETURNTRANSFER => true,
	  CURLOPT_ENCODING => "",
	  CURLOPT_MAXREDIRS => 10,
	  CURLOPT_TIMEOUT => 30,
	  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	  CURLOPT_CUSTOMREQUEST => "GET",
	  CURLOPT_HTTPHEADER => array(
	    "authorization: Bearer ".$access_token,
	  ),
	));

	$response = curl_exec($curl);
	$err = curl_error($curl);
	curl_close($curl);

	$ReturnAllContact = json_decode($response);

	if(isset($ReturnAllContact->category) && $ReturnAllContact->category == 'EXPIRED_AUTHENTICATION'){
		return false;
	} else {
		return $ReturnAllContact;
	}
}


//Create Contact
function Create_Batch_Contact_Data_Using_App($access_token, $json_data){
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => "https://api.hubapi.com/crm/v3/objects/contacts",
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "POST",
      CURLOPT_POSTFIELDS => $json_data,
      CURLOPT_HTTPHEADER => array(
        "content-type: application/json",
        "authorization: Bearer ".$access_token,
      ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
      echo "cURL Error #:" . $err;
    } else {
      return $response;
    }
}